/**
 * Copyright (c) 2012 EBM WebSourcing, 2012-2016 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see http://www.gnu.org/licenses/
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.cli.base.junit.shell;

/**
 * Utilities for the Petals Interactive CLI
 * 
 * @author Christophe DENEUX - EBM Websourcing
 */
public final class PetalsInteractiveCliUtils {

    private PetalsInteractiveCliUtils() {
        // NOP: Utility class --> No constructor
    }

    /**
     * Sets a specific property on Windows, so that interactive unit tests work.
     * <p>
     * This problem is met neither with other shells, nor in real conditions.
     * </p>
     * <p>
     * If the current OS is not part of the Windows family, then this method does nothing.
     * </p>
     * 
     * @param enable
     *            true to enable the hack, false otherwise
     */
    public static void hackForWindows(boolean enable) {

        // Hack for Windows and make unit tests work
        // Do not short cut the access to System.in
        String osName = System.getProperty("os.name");
        if (osName != null && osName.toLowerCase().contains("win"))
            System.setProperty("jline.WindowsTerminal.directConsole", String.valueOf(!enable));
        // End of hack
    }
}
